#ifndef __TCP_SERVER_H__
#define __TCP_SERVER_H__

#include "QUANTAnet_blockingTcp_c.hxx"
#include "TCPClient.h"

#define BUNCHOFCLIENTS 5

class CBTCPServer
{
public:
	static const int OK;
	static const int FAIL;

	CBTCPServer(int port=0, int numClients = BUNCHOFCLIENTS);
	virtual ~CBTCPServer();

	int SetAddress(int port);
	CTCPClient* Listen();
	int Receive(char* recvmesg, int& dataSize); 
	void ReplyToClients(char* sendmesg, int dataSize);
	void Close();

protected:
	QUANTAnet_blockingTcpServer_c* m_Server;
	int m_NumOfClients;
	CTCPClient** m_BunchSocket;
};

#endif