#include "QUANTAts_thread_c.hxx"
#include "BlockingTCPServer.h"
#include <string.h>

int port = 7001;
CBTCPServer server;
static QUANTAts_thread_c QUANTAThread;

static void *ExecuteApplicationThread(void *param)
{
	CTCPClient *client = (CTCPClient *)param;
	char buffer[TRANSMITTED_DATA_SIZE];
	int size = TRANSMITTED_DATA_SIZE;

	if (client) {
		while(client->Receive(buffer, size, QUANTAnet_tcpClient_c::BLOCKING) == QUANTAnet_tcpClient_c::OK) { // blocking
			printf("%s\n", buffer);
			char newData[512];
			strcpy(newData, "Received: ");
			strcat(newData, buffer);
			size = 512;
			server.ReplyToClients(newData, size); 
		}
	}

	delete client;
	return NULL;
}

int main(int argc, char** argv)
{
	if (argc > 1) {
		port = atoi(argv[1]);
	}
	printf("PORT: %d\n", port);
	server.SetAddress(port);

	CTCPClient* aClient;
#ifdef WIN32
	while (!GetAsyncKeyState(VK_ESCAPE)) {
#else
	while (true) {
#endif
		aClient = server.Listen(); // check for new connection
		if (aClient) {
			QUANTAThread.create(ExecuteApplicationThread, aClient);
		}
	}
	return 0;
}
